/*
  This function runs executable *path with arguments *arg
  
  Returns: 0 if success, DOS error code if error
*/

unsigned dosexec(char __far *path, char *arg)
{
  unsigned short int path_segment = ((unsigned long)path)>>16;
  unsigned short int path_offset = (unsigned short)path;
  char __far *args = _fmalloc(128*sizeof(char));
  char __far *parmb = _fcalloc(0x10,sizeof(char));
  unsigned short int arg_segment = ((unsigned long)parmb)>>16;
  unsigned short int arg_offset = (unsigned short)parmb;
  unsigned retval = 0;
  unsigned short int psp_segment;
  unsigned int n=0;
  char __far* __far * arg_string;

  if(!args || !parmb)
  {
    _ffree(args);
    _ffree(parmb);
    return 0x08;
  }

  // put argument string to args (the first byte is the count byte)
  if(arg)
  {
    for(;arg[n];n++)
      args[n+1] = arg[n];
    args[++n] = ' ';
  }
  args[n+1] = 0x0D;
  args[0] = n;
  
  //args[0]=strlen(&args[1])-1;

  // set bytes 0 and 1 to zero so that the child process inherits the environment variables
//  parmb[0] = 0x00;
//  parmb[1] = 0x00;
  // segment and offset to argument string  
  arg_string = (char __far* __far*)&parmb[2];
  *arg_string = args;

  // get the PSP segment
  __asm
  {
  // get the PSP segment    
    mov ah, 0x51
    int 0x21
    mov psp_segment, bx
  }
  // pointer (segment:offset) to first FCB
  parmb[6] = psp_segment>>8;
  parmb[7] = psp_segment<<8>>8;
  
  parmb[8] = 0;
  parmb[9] = 0x5c;

  // pointer to second FCB
  parmb[0xA] = parmb[6];
  parmb[0xB] = parmb[7];

  parmb[0xC] = 0;
  parmb[0xD] = 0x6c;

  if(_heapshrink())
    if(retval = _heapshrink())
      return retval;
  
  __asm
  {
    mov ah, 0x4B
    mov al, 0x00

    mov ds, path_segment
    mov dx, path_offset

    mov es, arg_segment
    mov bx, arg_offset

    int 0x21

    jnc noerror

    mov retval, ax

    noerror:
  }

  _ffree(args);
  _ffree(parmb);

  return retval;
}
