#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <dos.h>
#include <i86.h>

#include "..\extdlc.c"

#include "drvdef.c"

#include "drvstrc.c"

void putstr(unsigned char *string);

unsigned dosexec(char __far *path, char *arg);
void restore_videomode(void);
extern void __far (*driver_videomode)(void);

struct driver *drivers;

extern char *message;

unsigned driver_count = 0;

extern int videodriver;

/*unsigned char device_exists(unsigned driver, unsigned device)
{
  if(device < drivers[driver].dev_count)
    return 1;
  return 0;
}*/

int driver_id(char *name)
{
  int n = driver_count;

  while(n--)
  {
    if(!strcmp(drivers[n].dev_name, name))
      break;
  }

  return n;
}

int __far (*driver_func_ptr)();

int call_cmd_func_devnum(unsigned device, void __far *cmd, unsigned func_seg);
#pragma aux call_cmd_func_devnum = \
  "call dword ptr es:driver_func_ptr" \
  parm [bx] [dx ax] [es] value [ax];
int call_cmd_func_sdev(void __far *cmd, unsigned func_seg);
#pragma aux call_cmd_func_sdev = \
  "call dword ptr es:driver_func_ptr" \
  parm [dx ax] [es] value [ax];  
int dev_cmd(unsigned driver, int device, void __far *cmd)
{
  if(drivers[driver].cmd_func)
  {
    driver_func_ptr = drivers[driver].cmd_func;    
    if(drivers[driver].dev_count >= 1)
//      return (*drivers[driver].cmd_func)(device, cmd);
      return call_cmd_func_devnum(device, cmd, FP_SEG(&driver_func_ptr));
    if(drivers[driver].dev_count == -1)      
//      return (*drivers[driver].cmd_func)(cmd);
      return call_cmd_func_sdev(cmd, FP_SEG(&driver_func_ptr));
  }
  return -1;
}

int call_read_func_devnum(unsigned device, unsigned func_seg);
#pragma aux call_read_func_devnum = \
  "call dword ptr es:driver_func_ptr" \
  parm [ax] [es] value [ax];
int call_read_func_sdev(unsigned func_seg);
#pragma aux call_read_func_sdev = \
  "call dword ptr es:driver_func_ptr" \
  parm [es] value [ax];  
int dev_read(unsigned driver, int device)
{
/*  sprintf(message, "%p", drivers[driver].read_func);
  putstr(message);
  abort();*/
  
  if(drivers[driver].read_func)
  {
    driver_func_ptr = drivers[driver].read_func;        
    if(drivers[driver].dev_count >= 1)    
//      return (*drivers[driver].read_func)(device);
      return call_read_func_devnum(device, FP_SEG(&driver_func_ptr));
    if(drivers[driver].dev_count == -1)
      return call_read_func_sdev(FP_SEG(&driver_func_ptr));
  }
  return -1;
}

int call_write_func_devnum(unsigned device, int byte, unsigned func_seg);
#pragma aux call_write_func_devnum = \
  "call dword ptr es:driver_func_ptr" \
  parm [bx] [ax] [es] value [ax];
int call_write_func_sdev(int byte, unsigned func_seg);
#pragma aux call_write_func_sdev = \
  "call dword ptr es:driver_func_ptr" \
  parm [ax] [es] value [ax];  
int dev_write(unsigned driver, int device, unsigned char byte)
{
  if(drivers[driver].write_func)
  {
    driver_func_ptr = drivers[driver].write_func;            
    if(drivers[driver].dev_count >= 1)
//      return (*drivers[driver].write_func)(device, byte);
      return call_write_func_devnum(device, byte, FP_SEG(&driver_func_ptr));
    if(drivers[driver].dev_count == -1)      
//      return (*drivers[driver].write_func)(byte);
      return call_write_func_sdev(byte, FP_SEG(&driver_func_ptr));
  }
  return -1;
}

int call_open_func_devnum(int device, unsigned mode, unsigned func_seg);
#pragma aux call_open_func_devnum = \
  "call dword ptr es:driver_func_ptr" \
  parm [bx] [ax] [es] value [ax];
int call_open_func_sdev(unsigned mode, unsigned func_seg);
#pragma aux call_open_func_sdev = \
  "call dword ptr es:driver_func_ptr" \
  parm [ax] [es] value [ax];    
int dev_open(unsigned driver, int device, unsigned mode)
{
  if(drivers[driver].open_func)  
  {
//    sprintf(message, "%p", drivers[driver].open_func);
//    putstr(message);
    driver_func_ptr = drivers[driver].open_func;
    if(drivers[driver].dev_count >= 1)    
//      return (*drivers[driver].open_func)(device, mode);
      return call_open_func_devnum(device, mode, FP_SEG(&driver_func_ptr));
    if(drivers[driver].dev_count == -1)      
//      return (*drivers[driver].open_func)(mode);
      return call_open_func_sdev(mode, FP_SEG(&driver_func_ptr));
  }
  return -1;
}

int call_close_func_devnum(int device, unsigned func_seg);
#pragma aux call_close_func_devnum = \
  "call dword ptr es:driver_func_ptr" \
  parm [ax] [es] value [ax];
int call_close_func_sdev(unsigned func_seg);
#pragma aux call_close_func_sdev = \
  "call dword ptr es:driver_func_ptr" \
  parm [es] value [ax];
int dev_close(unsigned driver, int device)
{
  if(drivers[driver].close_func)
  {
    driver_func_ptr = drivers[driver].close_func;                    
    if(drivers[driver].dev_count >= 1)    
//      return (*drivers[driver].close_func)(device);
      return call_close_func_devnum(device, FP_SEG(&driver_func_ptr));
    if(drivers[driver].dev_count == -1)      
//      return (*drivers[driver].close_func)();
      return call_close_func_sdev(FP_SEG(&driver_func_ptr));
  }
  return -1;
}

int call_lseek_func_devnum(int device, int offset, unsigned func_seg);
#pragma aux call_lseek_func_devnum = \
  "call dword ptr es:driver_func_ptr" \
  parm [bx] [ax] [es] value [ax];
int call_lseek_func_sdev(int offset, unsigned func_seg);
#pragma aux call_lseek_func_sdev = \
  "call dword ptr es:driver_func_ptr" \
  parm [ax] [es] value [ax];  
int dev_lseek(unsigned driver, int device, int offset)
{
  if(drivers[driver].lseek_func)
  {
    driver_func_ptr = drivers[driver].lseek_func;                        
    if(drivers[driver].dev_count >= 1)    
//      return (*drivers[driver].lseek_func)(device, offset);
      return call_lseek_func_devnum(device, offset, FP_SEG(&driver_func_ptr));
    if(drivers[driver].dev_count == -1)      
//      return (*drivers[driver].lseek_func)(offset);
      return call_lseek_func_sdev(offset, FP_SEG(&driver_func_ptr));
  }
  return -1;
}

int call_fsync_func_devnum(int device, unsigned func_seg);
#pragma aux call_fsync_func_devnum =  \
  "call dword ptr es:driver_func_ptr" \
  parm [ax] [es] value [ax];
int call_fsync_func_sdev(unsigned func_seg);
#pragma aux call_fsync_func_sdev =  \
  "call dword ptr es:driver_func_ptr" \
  parm [es] value [ax];
int dev_fsync(unsigned driver, int device)
{
  if(drivers[driver].fsync_func)
  {
    driver_func_ptr = drivers[driver].fsync_func;                            
    if(drivers[driver].dev_count >= 1)    
//      return (*drivers[driver].fsync_func)(device);
      return call_fsync_func_devnum(device, FP_SEG(&driver_func_ptr));
    if(drivers[driver].dev_count == -1)      
//      return (*drivers[driver].fsync_func)();
      return call_fsync_func_sdev(FP_SEG(&driver_func_ptr));
  }
  return -1;
}

void video_mode(unsigned char mode);
extern unsigned char video;
void draw_screen(void);

extern unsigned char _VIDEO_MODE;

unsigned allocate_new_driver(void);
void install_display_driver(void __far * __far *sfunc_table);

/* This interrupt handler is called by the resident program before exiting.

   AX:BX = segment and offset where the function table is
   CX = device type (0 == normal device, 1 == graphics adapter)

   -1 is returned to AX if an error occurred.

   If driver was loaded successfully, 0 is returned.
*/
void __interrupt driver_installer(union INTPACK regs)
{
  unsigned pfunc_table_seg = regs.w.ax;
  unsigned pfunc_table_offset = regs.w.bx;
  unsigned device_type = regs.w.cx;
  unsigned sfunc_table_seg = regs.w.dx;
  unsigned sfunc_table_offset = regs.w.si;
  void __far * __far *pfunc_table = MK_FP(pfunc_table_seg, pfunc_table_offset);
  void __far * __far *sfunc_table = MK_FP(sfunc_table_seg, sfunc_table_offset);  
  unsigned di = driver_count;
  int (__far *__far *dfunc_table[FUNCTIONS])();
  unsigned n = 0;

  if(!allocate_new_driver())
  {
    video_mode(0x03);    
    regs.w.ax = -1;
    return;
  }

  dfunc_table[0] = &drivers[di].cmd_func;
  dfunc_table[1] = &drivers[di].read_func;  
  dfunc_table[2] = &drivers[di].write_func;
  dfunc_table[3] = &drivers[di].open_func;
  dfunc_table[4] = &drivers[di].close_func;
  dfunc_table[5] = &drivers[di].lseek_func;
  dfunc_table[6] = &drivers[di].fsync_func;
  
  do
    *dfunc_table[n] = pfunc_table[n];
  while(++n && pfunc_table[n] != (void __far *)-1);
  
  drivers[di].cmd_func_arglen = *(unsigned char*)&pfunc_table[++n];
  drivers[di].dev_count = *(unsigned char*)&pfunc_table[++n];  

//  printf("%p %p %p\n", pfunc_table[2], *dfunc_table[2], drivers[di].write_func);
  if(device_type == 1)
  {
    install_display_driver(sfunc_table);
    videodriver = driver_count;
  }

  regs.w.ax = 0;
}


unsigned short get_memory_allocation_strategy(void);
#pragma aux get_memory_allocation_strategy = \
"mov al, 0" \
"int 0x58" \
value [ ax ];

void set_memory_allocation_strategy(unsigned char strategy);
#pragma aux set_memory_allocation_strategy = \
"mov al, 1" \
"int 0x58" \
parm [ bx ];


int load_driver(char *program, char *modname)
{
  unsigned n = 0;
  unsigned old_driver_count = driver_count;
  char args[3];
  unsigned short memory_allocation_strategy = get_memory_allocation_strategy();
  // find free interrupt
  while(_dos_getvect(++n))
  {
    if(!n)
      return -1;
  }
  sprintf(args, "%X", n);
//  video_mode(0x03);    
  _dos_setvect(n, driver_installer);
  set_memory_allocation_strategy(0x82);  
  dosexec(program, args);
  set_memory_allocation_strategy(memory_allocation_strategy);
//  printf("%p\n", drivers[0].write_func);
//  delay(1000);
  if(_VIDEO_MODE != video)
  {
    restore_videomode();
  }
  draw_screen();  
  _dos_setvect(n, 0);

  if(old_driver_count != driver_count)
  {
//    drivers[old_driver_count].dev_name = modname;
    strncpy(drivers[old_driver_count].dev_name, modname, 5);
  }

  return 0;
}
