#include <dos.h>
#include <stdlib.h>
#include <string.h>

#include "..\extdlc.c"

#include "drvdef.c"
#include "drvstrc.c"

extern void __far (*put_pixel_screen)(unsigned int x, unsigned int y, unsigned color);
extern unsigned __far (*get_pixel_screen)(unsigned int x, unsigned int y);
extern unsigned char __far (*draw_rectangle_screen)(int x0, int y0, unsigned int width, unsigned int height, unsigned color);
extern unsigned char __far (*fill_screen_color)(unsigned color);
extern unsigned char _FONT_HEIGHT;
extern void __far (*update_screen)(void);
extern void __far (*driver_videomode)(void);


unsigned allocate_new_driver(void);
void video_mode(unsigned char mode);
extern unsigned driver_count;
extern struct driver *drivers;
extern int videodriver;
extern unsigned _RES_X;
extern unsigned _RES_Y;
extern unsigned char _VIDEO_MODE;
extern unsigned char video;

unsigned allocate_new_driver(void)
{
  void *new_pointer;  
  if(!driver_count++)
  {
    // allocate driver table
    drivers = calloc(driver_count, sizeof(struct driver));
    if(!drivers)
    {
      nomemory:
      --driver_count;
      return 0;
    }
  }
  else
  {
    new_pointer = realloc(drivers, driver_count*sizeof(struct driver));
    if(!new_pointer) goto nomemory;
    else drivers = new_pointer;
    memset(&drivers[driver_count-1], 0, sizeof(struct driver));
  }
  return driver_count;
}


void install_display_driver(void __far * __far *sfunc_table)
{
  put_pixel_screen = sfunc_table[0];
  get_pixel_screen = sfunc_table[1];
  draw_rectangle_screen = sfunc_table[2];
  fill_screen_color = sfunc_table[3];
  update_screen = sfunc_table[4];

  driver_videomode = sfunc_table[5];  
  
  _RES_X = (unsigned short)sfunc_table[6];
  _RES_Y = ((unsigned long)sfunc_table[6]) >> 16;

  video = _VIDEO_MODE = ((unsigned long)sfunc_table[7]) >> 16;
  _FONT_HEIGHT = *(unsigned char*)&sfunc_table[7];
}
