#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
//#include <i86.h>
//#include <time.h>
//#include <process.h>
#include <string.h>
#include <errno.h>
//#include <sys/types.h>
#include <direct.h>
#include <dos.h>
#include <malloc.h>

//#include "dalloc.c"
#include "extdlc.c"

#include "drvmod\drvstrc.c"
#include "structs.c"
#include "globals.c"
#include "constrct.c"
#include "vpu\vpustrct.c"
#include "settings.c"
#include "path.c"
#include "str.c"
#include "dosexec.c"
#include "sound.c"
#include "graphics.c"
#include "fonts.c"
#include "menus.c"
#include "keyboard.c"
#include "text.c"
#include "desktop.c"
#include "mouse.c"
#include "windows.c"
#include "errors.c"
#include "int23h.c"
#include "int24h.c"
#include "run.c"
#include "startup.c"

#include "runprmpt.c"
#include "dostime.c"
#include "clock.c"
#include "textview.c"
#include "fileman.c"
#include "cpanel.c"
#include "scrnsvr.c"
#include "arrwndws.c"
#include "vpucon.c"
#include "vpuprog.c"

#define MAX_WINDOWS 5

inline void start_program(void)
{
//  puts("Loading settings...");
  load_settings();
//  puts("Loading system font...");
  load_system_font(system_font_file, &system_font);
  load_system_font(monospace_font_file, &monospace_font);
//  puts("Preparing virtual processing units...");
  init_vcpu();
//  puts("Setting interrupts...");
  set_int24();
  set_int23();
//  puts("Setting environment variables...");
  path = getenv("PATH");
//  puts("Preparing desktop...");
  init_desktop();
//  puts("Loading desktop shortcuts...");
  load_desktop_shortcuts();
//  puts("Preparing variables...");
  filename_clipboard.pending_operation = 0;
  screensaver_timer = 0;
//  puts("Switching to graphical display mode...");
  video_mode(video);  
  draw_screen();

  if(mouse = init_mouse())
  {
    draw_mouse_cursor(1);
  }

  init_clock_window();

  draw_mouse_cursor(0);

  getcwd(&cwd, MAX_PATH);
  _dos_getdrive(&cwdrive);

  run_startup_programs();
}

inline void end_program(void)
{
  reset_vpu_interrupt_handlers();  
  video_mode(0x03);
  reset_int23();
  reset_int24();  
}

void call_drv_screenupdate(void)
{
  if(update_screen)
  {
    if(!windows[active_window]->fullscreen || windows[active_window]->scrmode == video)
      update_screen();
  }
}

int call_mouse_handler(int a)
{
  int retval = 0;
  call_drv_screenupdate();
  if(mouse)
  {    
    if(active_window != -1)
      retval = mouse_handler(windows[active_window]);
    else
      retval = mouse_handler(0);
    if(a == -1)
    {
      draw_mouse_cursor(0);       
      draw_screen();
      draw_mouse_cursor(1);
    }
  }
  if(retval) return retval;
  return a;
}

inline void start_arg1_prog(unsigned argc, char **argv)
{
  char argstr[256];
  char *ptr = argstr;
  unsigned n = 0;

  while(++n < argc)
  {
    strcpy(ptr, argv[n]);
    ptr += strlen(ptr);
    *ptr++ = ' ';
  }
  *ptr = 0;
  run_program(0, argv[0], argstr, 0);
}

void main(unsigned argc, char **argv)
{
  int a = 0;
  int c = 0;
  unsigned int n;
  unsigned int screensaver_secs = dostime()->s;

  start_program();

  if(argc > 1)
    start_arg1_prog(argc-1, &argv[1]);

  while(1)
  {
    if(screensaver_delay && screensaver_secs != dostime()->s)
    {
      screensaver_timer++;
      screensaver_secs = dostime()->s;
      if(screensaver_timer > screensaver_delay)
        screen_saver();
    }

    a = call_mouse_handler(a);
    // if a key is pressed
    if(kbhit())
    {
      screensaver_timer = 0;
      // if a function key (c==0)
      if(!(c = getch()))
        switch(c = getch())
        {
          // alt+tab          
          case 165:
            if(active_window!=-1 && windows[active_window]->fullscreen)
              minimize_window(windows[active_window]);
            if(window_count)
              unminimize_window(window_visibility_order[0]);
            draw_mouse_cursor(1);            
          break;
          //alt + M
          case 50:
            if(active_window!=-1)
            {
              a = window_menu(windows[active_window], 0);
              draw_mouse_cursor(2);
              goto actions;
            }
//            draw_mouse_cursor(1);               
          break;
          //alt+f4
          case 107:
            if(active_window >= 0)
            {
              a = 2;
              goto actions;
            }
          break;
          // alt+f3
          case 106:
            a = 5;
            goto actions;
          // alt+f2
          case 105:
            a = 50;
            goto actions;
          // alt + f5
          case 108:
            a = 51;
            goto actions;
          // alt + f6
          case 109:
            a = 52;
            goto actions;
          default:
            // if no window is active, use arrow keys to select active desktop icon
            if(active_window == -1)
            {
              draw_mouse_cursor(2);                             
              desktop_iconnav(c);
              desktop_iconmov(c);
//              draw_desktop();
//              draw_window_icons();
              draw_mouse_cursor(1);               
            }
            // else unget the keypress for the active window to process
            else
            {
              ungetch(c);
              c = 0;
              goto windowloop;
            } 
          break;
        }
      // if no special key
      else
        switch(c)
        {
          // enter
          case 13:
            // if no active window, do the currently selected desktop icon's thing
            if(active_window == -1)
              a = -6;
          break;
          // esc
          case 27:
            if(!window_count || windows[active_window]->hidden || windows[active_window]->function_pointer != &vpuconsole_program)
              if(!dialog(20, 20, 200, 50, 2, 1, 1, "Exit to dos?", "Exit", "Press [Yes] to exit, [No] to cancel"))
                goto endwhile;
          break;
        }
    }
    else
      c = -1;
    // loop active windows's function
    windowloop:    
    // this is a "multitasking" loop
    for(n=window_count;n--;)
    {
      if(windows[n]->function_pointer && !windows[n]->minimized)
      {
        running_window = windows[n];
        if(n == active_window)
          a = (*windows[n]->function_pointer)(windows[n], call_mouse_handler(a)-100, &c);
        else
          (*windows[n]->function_pointer)(windows[n], -100, 0);
      }
    }
    running_window = 0;

    if(screen_redraw)
    {
      draw_screen();
      draw_mouse_cursor(1);      
      screen_redraw=0;
    }

    actions:    
    switch(a)
    {
      case 1: window_kbdmove(windows[active_window]); draw_mouse_cursor(1); break;
      case 2: // window close
        // if the window is vpu console window, then also terminate the virtual machine
        if(windows[active_window]->function_pointer == &vpuconsole_program)
          delete_console(windows[active_window]->function_status);
        // if the window is created by a virtual machine, place a null pointer to the vpu struct
        else if(windows[active_window]->function_pointer == &vpuwindow_program)
          for(c=vpu_count;c--;)
            for(n=MAX_WINDOWS;n--;)
              if(vpus [c]->windows[n].window == windows[active_window])
              {
                vpus [c]->windows[n].window = 0;
                _ffree(vpus[c]->windows[n].renderer);
              }
        del_window(windows[active_window]); draw_mouse_cursor(1);
        a=0;
        break;
      case 4: window_kbdresize(windows[active_window]); draw_mouse_cursor(1); break;
      case -1: /*draw_window(windows[active_window], 1, 0); draw_mouse_cursor(1); */draw_screen(); break;
      break;
/*      case -9:
        draw_mouse_cursor(0);                             
//        draw_screen();
      break;*/
//      break;
      case -6:
        switch(icon_selected)
        {
          case 4:
            init_vpuconsole_window(0);
            break;
          case 3:
            init_clock_window();
          break;
          case 2:
            init_cpanel_window();
          break;
          case 1:
            init_fileman_window();
          break;
          case 0:
            init_run_window(0);
          break;
        }
        for(n=shortcut_count;n--;)
        {
          if(icon_selected == desktop_icon_count+n)
          {
            if(desktop_shortcuts[n].ask_args)
              init_run_window(desktop_shortcuts[n].path);
            else
              run_program(0, desktop_shortcuts[n].path, 0, 0);
          }
        }
//        draw_mouse_cursor(1);        
      break;
      case -4: case 3:
      if(windows[active_window]->resizable)
      {
        if(windows[active_window]->maximized)
        {
          unmaximize_window(windows[active_window]);
          screen_redraw=1;
        }
        else
          maximize_window(windows[active_window]);
        draw_mouse_cursor(1);
        windows[active_window]->resized=1;      
        break;          
      }
      case -5: case 5: case 50: showdesktop:
        if(active_window >= 0)
          minimize_window(windows[active_window]);
        if(a == 50)
          if(active_window >= 0)
            goto showdesktop;
          else
            for(n=window_count;n--;)
              if(windows[n]->function_pointer == &clock_program)
                unminimize_window(n);
        draw_mouse_cursor(1);        
      break;
      case 51:
        if(window_count)
          tile_windows();
        screen_redraw = 1;
      break;
      case 52:
        if(window_count)
          cascade_windows();
        screen_redraw = 1;
      break;
    }
//    if(a<100)
      a=0;
  }
  endwhile:
  end_program();
  exit(0);
//  return 0;
}


