/*
  This is the main function for the run dialog
*/

int rundialog_program(struct prog_window *window, int args, int *keypress)
{
  int c;
  unsigned char *textbox_content = window->window_grid[0]->text;
  unsigned char *argbox_content = window->window_grid[1]->text;
  unsigned char *wdbox_content = window->window_grid[2]->text;

  if(keypress)
  {
    switch(*keypress)
    {
      case 112: case 80:
        args=0;
        break;
      case 97: case 65:
        args=1;
        break;
      case 119: case 87:
        args=2;
        break;
      case 114: case 82:
        args=3;
        break;
      case 99: case 67:
        args=4;
        break;
    }
    *keypress = -1;
  }

  if(!args)
  {
    c = edit_text(window, 0);
    if(c==2) args=1;
    if(c==1) args=3;
  }
  if(args==1)
  {
    c = edit_text(window, 1);
    if(c==1) args=3;
    if(c==2) args=2;
  }
  if(args==2)
  {
    c = edit_text(window, 2);
    if(c==1) args=3;
  }
  if(args >= 3)
  {

    run_program(wdbox_content, textbox_content, argbox_content, 1);

    if(args==4)
    {
      // exit "application"
      del_window(window);
      draw_mouse_cursor(1);
      return -101;            
    }
  }
  return args+100;    
}

/*
  This function creates new window for the run dialog
  Returns: Pointer to the window struct
*/
struct prog_window *init_run_window(char *program)
{
  struct prog_window *retval = new_window(-1, -1, 300, 100, "Run program", 0, 1, 1, "ICONS/RUNPRMPT.ICO", &rundialog_program);

  if(!retval)
  {
    nomemory:
    if(retval) del_window(retval);
    nomemory();
    return 0;
  }

  if(!(window_textbox(retval, 110, 5, 180, program, 81)))
    goto nomemory;
  if(!(window_textbox(retval, 110, 5+_FONT_HEIGHT+8, 180, "", 128)))
    goto nomemory;
  if(!(window_textbox(retval, 110, 5+2*(_FONT_HEIGHT+8), 180, "", 68)))
    goto nomemory;
  if(!(window_button(retval, 10, 5+3*(_FONT_HEIGHT+8), 50, _FONT_HEIGHT+2, "\021Run", _WINDOW_BASICTEXTCOLOR)))
    goto nomemory;
  if(!(window_button(retval, 70, 5+3*(_FONT_HEIGHT+8), 100, _FONT_HEIGHT+2, "Run & \021close", _WINDOW_BASICTEXTCOLOR)))
    goto nomemory;
  if(!(window_text(retval, 5, 5, "\021Program path", _WINDOW_BASICTEXTCOLOR)))
    goto nomemory;
  if(!(window_text(retval, 5, 5+_FONT_HEIGHT+8, "\021Arguments", _WINDOW_BASICTEXTCOLOR)))
    goto nomemory;
  if(!(window_text(retval, 5, 5+2*(_FONT_HEIGHT+8), "\021Working directory", _WINDOW_BASICTEXTCOLOR)))
    goto nomemory;

  draw_window(retval, 1, 1);
  
  return retval;
}
