void vpu_instr_and(struct vpu *vpu)
{
  unsigned char reg0 = vpu->code[vpu->code_segment][vpu->ip++];
  unsigned char reg1 = vpu->code[vpu->code_segment][vpu->ip++];

  if(reg0 & 0x80 && reg1 & 0x80)
    vpu->regs[reg0 & 0x07] &= vpu->regs[reg1 & 0x07];

  else if(reg0 & 0x80)
    vpu->regs[reg0 & 0x07] &= vpu->byteregs[reg1 & 0x0F];

  else if(reg1 & 0x80)
    vpu->byteregs[reg0 & 0x0F] &= vpu->regs[reg1 & 0x07];

  else
    vpu->byteregs[reg0 & 0x0F] &= vpu->byteregs[reg1 & 0x0F];
  
  vpu_set_sign(vpu, reg0);  
}

void vpu_instr_or(struct vpu *vpu)
{
  unsigned char reg0 = vpu->code[vpu->code_segment][vpu->ip++];
  unsigned char reg1 = vpu->code[vpu->code_segment][vpu->ip++];

  if(reg0 & 0x80 && reg1 & 0x80)
    vpu->regs[reg0 & 0x07] |= vpu->regs[reg1 & 0x07];

  else if(reg0 & 0x80)
    vpu->regs[reg0 & 0x07] |= vpu->byteregs[reg1 & 0x0F];

  else if(reg1 & 0x80)
    vpu->byteregs[reg0 & 0x0F] |= vpu->regs[reg1 & 0x07];

  else
    vpu->byteregs[reg0 & 0x0F] |= vpu->byteregs[reg1 & 0x0F];
  
  vpu_set_sign(vpu, reg0);    
}

void vpu_instr_xor(struct vpu *vpu)
{
  unsigned char reg0 = vpu->code[vpu->code_segment][vpu->ip++];
  unsigned char reg1 = vpu->code[vpu->code_segment][vpu->ip++];

  if(reg0 & 0x80 && reg1 & 0x80)
    vpu->regs[reg0 & 0x07] ^= vpu->regs[reg1 & 0x07];

  else if(reg0 & 0x80)
    vpu->regs[reg0 & 0x07] ^= vpu->byteregs[reg1 & 0x0F];

  else if(reg1 & 0x80)
    vpu->byteregs[reg0 & 0x0F] ^= vpu->regs[reg1 & 0x07];

  else
    vpu->byteregs[reg0 & 0x0F] ^= vpu->byteregs[reg1 & 0x0F];
  
  vpu_set_sign(vpu, reg0);    
}


void vpu_instr_inv(struct vpu *vpu)
{
  unsigned char reg0 = vpu->code[vpu->code_segment][vpu->ip++];

  if(reg0 & 0x80)
    vpu->regs[reg0 & 0x07] = ~vpu->regs[reg0 & 0x07];

  else
    vpu->byteregs[reg0 & 0x0F] = ~vpu->byteregs[reg0 & 0x0F];     
}

void vpu_instr_shl(struct vpu *vpu)
{
  unsigned char reg0 = vpu->code[vpu->code_segment][vpu->ip++];
  unsigned char reg1 = vpu->code[vpu->code_segment][vpu->ip++];

  if(reg0 & 0x80 && reg1 & 0x80)
    vpu->regs[reg0 & 0x07] <<= vpu->regs[reg1 & 0x07];

  else if(reg0 & 0x80)
    vpu->regs[reg0 & 0x07] <<= vpu->byteregs[reg1 & 0x0F];

  else if(reg1 & 0x80)
    vpu->byteregs[reg0 & 0x0F] <<= vpu->regs[reg1 & 0x07];

  else
    vpu->byteregs[reg0 & 0x0F] <<= vpu->byteregs[reg1 & 0x0F];
}

void vpu_instr_shr(struct vpu *vpu)
{
  unsigned char reg0 = vpu->code[vpu->code_segment][vpu->ip++];
  unsigned char reg1 = vpu->code[vpu->code_segment][vpu->ip++];

  if(reg0 & 0x80 && reg1 & 0x80)
    vpu->regs[reg0 & 0x07] >>= vpu->regs[reg1 & 0x07];

  else if(reg0 & 0x80)
    vpu->regs[reg0 & 0x07] >>= vpu->byteregs[reg1 & 0x0F];

  else if(reg1 & 0x80)
    vpu->byteregs[reg0 & 0x0F] >>= vpu->regs[reg1 & 0x07];

  else
    vpu->byteregs[reg0 & 0x0F] >>= vpu->byteregs[reg1 & 0x0F];
}

