void condjump_debug(unsigned char res)
{
  if(res)
    putstr("Condition satisfied, performing jump");
  else
    putstr("Condition not satisfied");
}

void vpu_instr_cmp(struct vpu *vpu)
{
  unsigned char reg0 = vpu->code[vpu->code_segment][vpu->ip++];
  unsigned char reg1 = vpu->code[vpu->code_segment][vpu->ip++];

  if(reg0 & 0x80 && reg1 & 0x80)
    vpu->compreg = vpu->regs[reg0 & 0x07] - vpu->regs[reg1 & 0x07];

  else if(reg0 & 0x80)
    vpu->compreg = vpu->regs[reg0 & 0x07] - vpu->byteregs[reg1 & 0x0F];

  else if(reg1 & 0x80)
    vpu->compreg = vpu->byteregs[reg0 & 0x0F] - vpu->regs[reg1 & 0x07];

  else
    vpu->compreg = vpu->byteregs[reg0 & 0x0F] - vpu->byteregs[reg1 & 0x0F];

  if(debug)
  {
    sprintf(message, "Comparison result: %i\n", vpu->compreg);
    putstr(message);
  }
  if(vpu->compreg < 0) vpu->flags.sign = 1;
  else vpu->flags.sign = 0;
}

void vpu_instr_je(struct vpu *vpu)
{
  if(!vpu->compreg)
  {
    vpu->ip = *(unsigned short*)&vpu->code[vpu->code_segment][vpu->ip];
    if(debug)
    {
      condjump_debug(1);
    }
  }
  else
  {
    vpu->ip+=2;
    if(debug)
    {
      condjump_debug(0);
    }
  }
}

void vpu_instr_jne(struct vpu *vpu)
{
  if(vpu->compreg)
  {
    vpu->ip = *(unsigned short*)&vpu->code[vpu->code_segment][vpu->ip];
    if(debug)
    {
      condjump_debug(1);
    }
  }
  else
  {
    vpu->ip+=2;
    if(debug)
    {
      condjump_debug(0);
    }
  }
}

void vpu_instr_jg(struct vpu *vpu)
{
  if(vpu->compreg > 0)
  {
    vpu->ip = *(unsigned short*)&vpu->code[vpu->code_segment][vpu->ip];
    if(debug)
    {
      condjump_debug(1);
    }
  }
  else
  {
    vpu->ip+=2;
    if(debug)
    {
      condjump_debug(0);
    }
  }
}

void vpu_instr_jl(struct vpu *vpu)
{
  if(vpu->compreg < 0)
  {
    vpu->ip = *(unsigned short*)&vpu->code[vpu->code_segment][vpu->ip];
    if(debug)
    {
      condjump_debug(1);
    }
  }
  else
  {
    vpu->ip+=2;
    if(debug)
      condjump_debug(0);
  }
}


void vpu_instr_jge(struct vpu *vpu)
{
  if(vpu->compreg >= 0)
  {
    vpu->ip = *(unsigned short*)&vpu->code[vpu->code_segment][vpu->ip];
    if(debug)
    {
      condjump_debug(1);
    }
  }
  else
  {
    vpu->ip+=2;
    if(debug)
      condjump_debug(0);
  }
}

void vpu_instr_jle(struct vpu *vpu)
{
  if(vpu->compreg <= 0)
  {
    vpu->ip = *(unsigned short*)&vpu->code[vpu->code_segment][vpu->ip];
    if(debug)
    {
      condjump_debug(1);
    }
  }
  else
  {
    vpu->ip+=2;
    if(debug)
      condjump_debug(0);
  }
}

void vpu_instr_jcz(struct vpu *vpu)
{
  if(!vpu->regs[2])
  {
    vpu->ip = *(unsigned short*)&vpu->code[vpu->code_segment][vpu->ip];
    if(debug)
    {
      condjump_debug(1);
    }
  }
  else
  {
    vpu->ip+=2;
    if(debug)
      condjump_debug(0);
  }
}

void vpu_instr_jfs(struct vpu *vpu)
{
  unsigned short operand0 = *(unsigned short*)&vpu->code[vpu->code_segment][vpu->ip];
  vpu->ip+=2;


  if(*(unsigned short*)&vpu->flags & operand0)
  {
    vpu->ip = *(unsigned short*)&vpu->code[vpu->code_segment][vpu->ip];
    if(debug)
    {
      condjump_debug(1);
    }
  }
  else
  {
    vpu->ip+=2;
    if(debug)
      condjump_debug(0);
  }
}

void vpu_instr_jfns(struct vpu *vpu)
{
  unsigned short operand0 = *(unsigned short*)&vpu->code[vpu->code_segment][vpu->ip];
  vpu->ip+=2;

  if(!(*(unsigned short*)&vpu->flags & operand0))
  {
    vpu->ip = *(unsigned short*)&vpu->code[vpu->code_segment][vpu->ip];
    if(debug)
    {
      condjump_debug(1);
    }
  }
  else
  {
    vpu->ip+=2;
    if(debug)
      condjump_debug(0);
  }
}
