void inc_debug_info(unsigned newvalue)
{
  sprintf(message, "New unsigned value is %u", newvalue);
  putstr(message);
}

void vpu_instr_inc(struct vpu *vpu)
{
  unsigned char reg = vpu->code[vpu->code_segment][vpu->ip++];
  if(reg & 0x80)
  {
    vpu->regs[reg & 0x07]++;
    if(!vpu->regs[reg & 0x07])
      vpu->flags.overflow=1;
    if(debug)
    {
      inc_debug_info(vpu->regs[reg & 0x07]);
    }
  }
  else
  {
    vpu->byteregs[reg & 0x0F]++;
    if(!vpu->byteregs[reg & 0x0F])
      vpu->flags.overflow=1;
    if(debug)
    {
      inc_debug_info(vpu->byteregs[reg & 0x0F]);
    }
  }
}

void vpu_instr_dec(struct vpu *vpu)
{
  unsigned char reg = vpu->code[vpu->code_segment][vpu->ip++];
  if(debug)
    putstr("  Instruction type: DEC, ");
  if(reg & 0x80)
  {
    vpu->regs[reg & 0x07]--;
    if(vpu->regs[reg & 0x07] == 0xFFFF)
      vpu->flags.overflow=1;
    if(debug)
    {
      inc_debug_info(vpu->regs[reg & 0x07]);
    }
  }
  else
  {
    vpu->byteregs[reg & 0x0F]--;
    if(vpu->byteregs[reg & 0x0F] == 0xFF)
      vpu->flags.overflow=1;
    if(debug)
    {
      inc_debug_info(vpu->byteregs[reg & 0x0F]);
    }
  }

}
