#include <conio.h>
#include <dos.h>

#include "..\extdlc.c"

#include "serdef.c"

extern unsigned short __far *serialbase;
extern struct serport_buffer __far *serport_buffer[];

inline unsigned char serial_flow_control_send(unsigned char port)
{
  if(serport_buffer[port]->flow_control & 0x01)
  {
    // XON/XOFF
    if(serport_buffer[port]->xoff_received)
      return 1;
  }
  if(serport_buffer[port]->flow_control & 0x02)  
  {  
    // RTS/CTS
    // check CTS line
    if(!(inp(serialbase[port]+6) & 0x10))
      return 1;      
  }
  return 0;
}


unsigned char serial_write(unsigned char port, unsigned char chr)
{
  unsigned char overruns = 0;
  unsigned short retries = 0;

  // wait until bit 5 clears  
  while(!(inp(serialbase[port]+5) & 0x20));
  // check flow control
  while(++retries && serial_flow_control_send(port))
  {
    if(retries > 0xFFF0)
      delay(SERIALCOMM_WAIT_INTERVAL);
  }  

  retry:
  if(overruns++) delay(SERIALCOMM_WAIT_INTERVAL);
  if(!retries || overruns == 0xFF) return 1;
  outp(serialbase[port], chr);
  if(inp(serialbase[port]+5) & 0x02)
    goto retry;  
  
  return 0;
}


