void vpu_instr_memcpy(struct vpu *vpu)
{
//  unsigned n = 0;

  if(debug)
  {
    sprintf(message, "  Instruction: MEMCPY %u bytes from segment %u offset %u to segment %u offset %u", vpu->regs[4], vpu->regs[0], vpu->regs[1], vpu->regs[2], vpu->regs[3]);
    putstr(message);
  }
//  while(n++ < 4)
  if(vpu->regs[0] >= vpu->data_count || vpu->regs[2] >= vpu->data_count)
  {
    putstr("Too big value for data segment!");
    return;
  }

  if(!memory_allowed(vpu, vpu->regs[1] + vpu->regs[4]) || !memory_allowed(vpu, vpu->regs[3] + vpu->regs[4]))
  {
    putstr("Program tried to MEMCPY outside of data segments!\n");
    return;
  }

/*  while(vpu->regs[4]--)
  {
    vpu->data[vpu->regs[2]][vpu->regs[3]++] = vpu->data[vpu->regs[0]][vpu->regs[1]++];
  }*/

  memcpy(&vpu->data[vpu->regs[2]][vpu->regs[3]], &vpu->data[vpu->regs[0]][vpu->regs[1]], vpu->regs[4]);
  vpu->regs[1] = vpu->regs[3] += vpu->regs[4];
  vpu->regs[4] = 0;
}

void vpu_instr_memset(struct vpu *vpu)
{
  unsigned char copy_byte;

  if(debug)
  {
    sprintf(message, "  Instruction: MEMSET %u bytes - value from register dl to segment %u offset %u", vpu->regs[2], vpu->regs[0], vpu->regs[1]);
    putstr(message);
  }

  if(vpu->regs[0] >= vpu->data_count)
  {
    putstr("Too big value for data segment!");
    return;
  }

  if(!memory_allowed(vpu, vpu->regs[1] + vpu->regs[2]))
  {
    putstr("Program tried to MEMSET outside of data segments!\n");
    return;
  }

  copy_byte = vpu->byteregs[6];

/*  while(vpu->regs[2]--)
  {
    vpu->data[vpu->regs[0]][vpu->regs[1]++] = copy_byte;
  }*/

  memset(&vpu->data[vpu->regs[0]][vpu->regs[1]], copy_byte, vpu->regs[2]);
  vpu->regs[1] += vpu->regs[2];
  vpu->regs[2] = 0;

}
