//#define SCR_ROWS VPUCON_LINES
#define SCR_COLS VPUCON_COLS

char vpuconsole_window_title[] = "VPU Console";
//char vpu_welcome_msg[] = "Virtual CPU Console v. 0.1 alpha";

extern struct vpu **vpus;

extern unsigned char debug;

extern unsigned char SCR_ROWS;

extern unsigned line_num;

void delete_vpu(struct vpu *vpu);

int init_instruction_table(void);

int init_vcpu(void)
{
  if(!init_instruction_table())
    return 1;
  return 0;
}

unsigned *cursor_row;
unsigned *cursor_col;

void vpucon_caret(unsigned row, unsigned col, unsigned char remove)
{
//  struct console_struct *console_status = running_console->function_status;
  unsigned char linecolor;
  if(dostime()->s&1 && !remove) linecolor=_TEXTBOX_TEXTCOLOR;
  else linecolor=_TEXTBOX_BGCOLOR;

//  if(running_console->function_status == windows[active_window]->function_status)
    draw_line(running_console->x+running_console->window_grid[0]->x+col*9+2,
      running_console->y+running_console->window_grid[0]->y+(2+row)*(_FONT_HEIGHT+2),
      running_console->x+running_console->window_grid[0]->x+col*9+8,
      running_console->y+running_console->window_grid[0]->y+(2+row)*(_FONT_HEIGHT+2), linecolor);    
}

inline void vpuconsole_clearrow(struct prog_window *window, unsigned row)
{
//  struct console_struct *console_status = window->function_status;
  window->window_grid[0]->items[row][0] = 0;
  draw_rectangle(window->x+window->window_grid[0]->x,
    window->y+window->window_grid[0]->y+_FONT_HEIGHT+2+row*(_FONT_HEIGHT+2),
    window->window_grid[0]->width,
    _FONT_HEIGHT+3, _TEXTBOX_BGCOLOR);
}

void clear_row(unsigned row)
{
  vpuconsole_clearrow(running_console, row);
}

inline void vpuconsole_clearscr(struct prog_window *window)
{
  struct console_struct *console_status = window->function_status;      
//  unsigned n = VPUCON_LINES;
  unsigned n = console_status->lines;
  while(n--)
    window->window_grid[0]->items[n][0] = 0;
  console_status->row=0;
  console_status->col=0;
}

void clear_console(void)
{
  vpuconsole_clearscr(running_console);
}

inline void fastscroll(struct prog_window *window)
{
  int top = window->y+_FONT_HEIGHT+2+window->window_grid[0]->y;
  int left = window->x+window->window_grid[0]->x;
  int scroll_width = window->window_grid[0]->width;
  int scroll_height = window->window_grid[0]->height-_FONT_HEIGHT-2;
  unsigned row, n;
  char __far *dstbuff, *srcbuff;
  unsigned right = left+scroll_width;
  struct console_struct *console_status = window->function_status;        

  draw_mouse_cursor(2);

  if(left<0)
  {
    scroll_width += left;
    left=0;
  }
  if(top<0)
  {
    scroll_height += top;
    top=0;
  }
  if(top+scroll_height+_FONT_HEIGHT+2>_RES_Y-1)
    scroll_height -= (top+scroll_height+_FONT_HEIGHT+2)-_RES_Y;
  if(left+scroll_width>_RES_X-1)
    scroll_width -= (left+scroll_width)-_RES_X;
  if(scroll_height<0 || scroll_width<0) return;


  scroll_width >>= 3;
  scroll_width--;  

  for(row=0;row<scroll_height;row++)
  {
    for(n=7-(left&7);n;n--)
      put_pixel(left+n, top+row, get_pixel(left+n, top+row+_FONT_HEIGHT+2));
    for(n=right&7;n;n--)
      put_pixel(right-n, top+row, get_pixel(right-n, top+row+_FONT_HEIGHT+2));      
  }

  left >>= 3;    
  left++;

  if(_VIDEO_MODE != 0x06)
  {
    if(_VIDEO_MODE == 0x10 || _VIDEO_MODE == 0x12)
    {
      outp(0x03CE, 0x05);
      outp(0x03CF, 0x02);
  
      outp(0x03CE, 0x08);
    
      outp(0x03CF, 0x00);
    }    
    for(row=0;row<scroll_height;row++)
    {
      dstbuff = &VGA[(top+row)*80+left];
      srcbuff = &VGA[(top+row+_FONT_HEIGHT+2)*80+left];
      for(n=scroll_width;n--;)
      {
        dstbuff[n] = srcbuff[n];
      }      
    }
  }
  else
  {
    for(row=0;row<scroll_height;row++)
    {
      dstbuff = &VGA[((top+row)>>1)*80+left];
      srcbuff = &VGA[((top+row+_FONT_HEIGHT+2)>>1)*80+left];
      if((row&0x01))
      {
        dstbuff += 0x2000;
        srcbuff += 0x2000;
      }
      
      for(n=scroll_width;n--;)
      {
        dstbuff[n] = srcbuff[n];
      }      
    }
  }
  
  ega4_lastoperation=0;
  vpuconsole_clearrow(window, console_status->lines-1);

  draw_mouse_cursor(1);
  
}

inline void vpuconsole_scrollup(struct prog_window *window)
{
  unsigned row = 0;
  unsigned col;
  struct console_struct *console_status = window->function_status;      
  
  do
  {
    for(col=0;col<VPUCON_COLS;col++)
      window->window_grid[0]->items[row][col] = window->window_grid[0]->items[row+1][col];
  }
  while(++row < console_status->lines);

  if(windows[active_window] == window && videodriver == -1)
  {
    if(_VIDEO_MODE != 0x13)
      fastscroll(window);   
  }
  else
  {
    vpuconsole_clearrow(window, console_status->lines-1);
    if(!windows[active_window]->fullscreen)
      window_drawelement(window, 0);      
  }
}

inline void vpuconsole_incrow(struct prog_window *window)
{
  struct console_struct *console_status = window->function_status;
  vpucon_caret(console_status->row, console_status->col, 1);  
  if(++console_status->row == console_status->lines)
  {
    console_status->row--;
    vpuconsole_scrollup(window);
  }
  console_status->col=0;
//  window_drawelement(running_console, 0);    
}

void inc_row(void)
{
  vpuconsole_incrow(running_console);
}

void move(unsigned row, unsigned col)
{
  struct console_struct *console_status = running_console->function_status;
  vpucon_caret(console_status->row, console_status->col, 1);  
  console_status->row = row;
  console_status->col = col;
}

inline void vpuconsole_printchar(struct prog_window *window, unsigned char chr)
{
  struct console_struct *console_status = window->function_status;
  vpucon_caret(console_status->row, console_status->col, 1);
  window->window_grid[0]->items[console_status->row][console_status->col++] = chr;
  window->window_grid[0]->items[console_status->row][console_status->col] = 0;
  draw_char(chr, window->x+window->window_grid[0]->x-7+console_status->col*9, window->y+_FONT_HEIGHT+4+window->window_grid[0]->y+console_status->row*(_FONT_HEIGHT+2),
    _TEXTBOX_TEXTCOLOR, _FONT_HEIGHT, monospace_font);
  if(console_status->col == VPUCON_COLS)
    vpuconsole_incrow(window);
}

void mvaddch(unsigned row, unsigned col, unsigned char chr)
{
  unsigned oldrow = *cursor_row;
  unsigned oldcol = *cursor_col;
  move(row, col);
  vpuconsole_printchar(running_console, chr);
  move(oldrow, oldcol);
}

inline void vpuconsole_printtxt(struct prog_window *window, unsigned char *string)
{
  while(*string)
  {
    vpuconsole_printchar(window, *string++);
  }
}

void print_text(unsigned row, unsigned col, unsigned char *str)
{
  move(row, col);
  vpuconsole_printtxt(running_console, str);    
}

inline void vpuconsole_putstr(struct prog_window *window, unsigned char *string)
{
  steps = 0;
  vpuconsole_printtxt(window, string);
  vpuconsole_incrow(window);
}

void putstr(unsigned char *string)
{
  vpuconsole_putstr(running_console, string);
}

void refresh(void)
{
  window_drawelement(running_console, 0);    
}

void scroll_up(void)
{
  vpuconsole_scrollup(running_console);
}

void printchar(unsigned char chr)
{
  vpuconsole_printchar(running_console, chr);
}

int vpuconsole_getch(void)
{
  int retval;
  struct console_struct *console_status = running_console->function_status;

  if(console_status->keybuff[0] != -1)
  {
    console_status->waiting_for_key=0;
    retval = console_status->keybuff[0];
    if(!retval)
      console_status->keybuff[0] = console_status->keybuff[1];
    else
      console_status->keybuff[0] = -1;
    return retval;
  }
  console_status->waiting_for_key=0;
  return -1;
}

int getchr(void)
{
  int c = getch();
  printchar(c);
  return c;
}

int vpuconsole_keypress(struct prog_window *window, int *keypress)
{
  struct console_struct *console_status = window->function_status;

  console_status->keybuff[0] = *keypress;
  if(!*keypress)
    console_status->keybuff[1] = getch();
  
  return 0;
}

//#include "vpu/console/main.c"
unsigned char commandline(struct console_struct *);

void code_editor(struct console_struct *);

unsigned char vpu_run_program(struct console_struct *vpu);

unsigned char vpu_step(struct vpu *vpu);

extern unsigned symbol_count;
extern unsigned char **data;
extern unsigned datap_segment;
extern unsigned datap_offset;
extern void *symbols;
extern unsigned char pass;

unsigned char vpu_has_active_window(struct vpu *vpu)
{
  if(windows[active_window] == running_console
   || ((struct vpu_progwindow *)windows[active_window]->function_status)->vcpu == ((struct console_struct *)running_console->function_status)->vcpu)
    return 1;
  return 0;
}

void vpu_cwd(struct vpu *vpu)
{
  static unsigned chddir = 0;
  
  if(vpu)
  {
    if(vpu->cwd[1] == ':')
      chdrive(*vpu->cwd);
    if(chdir(vpu->cwd) == -1)
      vpu->cwd[0] = 0;
    chddir = 1;
  }
  else if(chddir)
  {
    chdir(cwd);
    chdrive(0);
    chddir = 0;  
  }
}

int con_write_stdin(unsigned char chr)
{
  void *new_pointer;

  if(chr == 8)
  {
    clear_row(*cursor_row);
    if(((struct console_struct*)running_console->function_status)->input_col)
    {
      ((struct console_struct*)running_console->function_status)->con_stdin.buff
        [--((struct console_struct*)running_console->function_status)->input_col] = 0;
      print_text(*cursor_row, 0, ((struct console_struct*)running_console->function_status)->con_stdin.buff);
    }
    move(*cursor_row, ((struct console_struct*)running_console->function_status)->input_col);      
    return 0;
  }

  ((struct console_struct*)running_console->function_status)->con_stdin.buff
    [((struct console_struct*)running_console->function_status)->input_col++] = chr;    

  if(chr == 13)
    inc_row();
  else
    printchar(chr);

  if(((struct console_struct*)running_console->function_status)->input_col
    == ((struct console_struct*)running_console->function_status)->con_stdin.len-1)
  {
    new_pointer = realloc(((struct console_struct*)running_console->function_status)->con_stdin.buff,
      (((struct console_struct*)running_console->function_status)->con_stdin.len += 32)*sizeof(char));
    if(!new_pointer)
      return -1;
    ((struct console_struct*)running_console->function_status)->con_stdin.buff = new_pointer;
  }

  ((struct console_struct*)running_console->function_status)->con_stdin.buff
    [((struct console_struct*)running_console->function_status)->input_col] = 0;

  return 0;
}

char *getcommand(struct console_struct *con_struct, char *retval);

int prepare_vpu_steps(struct vpu *vpu);

unsigned char vpu_run(struct vpu *vpu);

int vpuconsole_program(struct prog_window *window, int args, int *keypress)
{
  unsigned n;
  int c;
  struct console_struct *console_status = window->function_status;
  unsigned char dostimems = dostime()->ss;
  
//  steps = console_status->vcpu->priority;
//  if(vpu_has_active_window(console_status->vcpu))
//   steps <<= 2;
//  if(prepare_vpu_steps(console_status->vcpu))
//    goto close_con;

//  vpu_cwd(console_status->vcpu);

  data = console_status->vcpu->data;
  SCR_ROWS = console_status->lines;
  running_console = window;
  cursor_row = &console_status->row;
  cursor_col = &console_status->col;

  vpucon_caret(*cursor_row, *cursor_col, 0);  

  if(console_status->runmode == 3)
    goto runmode3;
  else
  {
    symbol_count = console_status->symbol_count;    
    line_num = console_status->asm_line;
    datap_segment = console_status->datap_segment;
    datap_offset = console_status->datap_offset;
    debug = console_status->debug;
    symbols = console_status->symbols;
//    vpucon_caret(console_status->row, console_status->col, 0);    
  }

  if(console_status->vcpu->exiting)
  {
    sprintf(message, "Exited with return code %u", console_status->vcpu->regs[1]);
    putstr(message);
    console_status->vcpu->exiting = 0;
  }
 
  if(!console_status->editmode)
  {
    if(console_status->runmode == 3)
    {
      runmode3:
      do
        switch(vpu_run(console_status->vcpu))
        {
//          case 3: putstr("returned 3");            
          case 0: break;
          case 1:
            show_error_msg("Error!");
          case 2:
            goto close_con;
        }
      while(dostimems == dostime()->ss);        
      goto end;
    }
    else if(console_status->runmode == 2)
    {
      if(vpu_run_program(console_status))
      {
        console_status->runmode = 0;
        pass = 0;
      }
    }
    else if(console_status->runmode == 1)
    {
      vpu_run_program(console_status);
      pass = 0;
      console_status->runmode = 0;      
    }
    else
      if(!commandline(console_status))
        goto close_con;
  }
  else
    code_editor(console_status);

  // if another console has the focus for some reason - if, for example, a new VPU process has been spawned by this console -
  // then do not save these
  if(running_console == window)
  {
    console_status->asm_line = line_num;
    console_status->symbol_count = symbol_count;
    console_status->datap_segment = datap_segment;
    console_status->datap_offset = datap_offset;
    console_status->debug = debug;
    console_status->symbols = symbols;
  }       
  
  end:
//  if(console_status->console_kill)
//    goto close_con;
  vpu_cwd(0);
  if(keypress)
  {
    vpuconsole_keypress(window, keypress);
    *keypress = -1;
    if(console_status->runmode)
    {
      if(console_status->keybuff[0] >= 0)
        if(con_write_stdin(console_status->keybuff[0]))
          putstr(outofmemory);
    }
  } 
  return args + 100;
  close_con:
  vpu_cwd(0);
  for(n=window_count;n--;)
    if(windows[n] == running_console)
      set_active_window(n, 0);
  return 2;
}

int new_console(struct console_struct *, char *filename);

//extern char response_ready[];

struct prog_window *init_vpuconsole_window(char *filename)
{
  struct prog_window *retval;
  struct window_element *element;
  unsigned n = VPUCON_LINES;
  unsigned char **con_lines = calloc(VPUCON_LINES, sizeof(char*));
  char *title;

  if(!filename)
    title = vpuconsole_window_title;
  else
    title = filename;
/*  {
    title = malloc(82 * sizeof(char));
    strcpy(title, filename);
  }*///memory leak fixed

  if(!con_lines || !(retval = new_window(-1, -1, (10*VPUCON_COLS)+2, (2+_FONT_HEIGHT)*VPUCON_LINES+3, title, 0, 1, 0, "ICONS/VPUCON.ICO", &vpuconsole_program)))
  {
    nomemory:
    nomemory();    
    return 0;
  }

  while(n--)
  {
    con_lines[n] = calloc(VPUCON_COLS+1, sizeof(char));
    if(!con_lines[n])
    {
      deletelines:
      while(++n < VPUCON_LINES)
        free(con_lines[n]);
      free(con_lines);        
      goto deletewindow;
    }
  }
  
  if(!(element = window_list(retval, 1, 1, (10*VPUCON_COLS), (2+_FONT_HEIGHT)*VPUCON_LINES+1, con_lines, VPUCON_LINES)))
  {
    goto deletelines;
    deletewindow:
    del_window(retval);
    goto nomemory;
  }
  free(con_lines);

  element->active = 0;
  element->monospace = 1;

  if(!(retval->function_status = calloc(1, sizeof(struct console_struct))))
    goto deletewindow;
  ((struct console_struct*)retval->function_status)->keybuff[0] = -1;

  draw_window(retval, 1, 1);

  running_console = retval;

  switch(new_console(retval->function_status, filename))
  {
    case 1:
      delete_console(retval->function_status);
      goto deletewindow;
    case 2:
      show_error_msg("Error while loading application.");
      delete_console(retval->function_status);
      del_window(retval);
      return 0;    
  }
  return retval;  
}

#include "vpupwin.c"
